/* Definitions for layout/processing of input eventsearch params ... */

#ifndef EVENTSEARCHDATAInc
#define EVENTSEARCHDATAInc

#define MAX_NODES 64
#define MAX_EVENTSEARCH_ACTIONS  16

/* EventSearch Definition descriptor record ... */

typedef struct eventsearchaction {
  char action_name[NAMELEN];
  int type;
  int (*fn)();
  void * p0;
  int p1;
  int p2;
  int p3;
  int p4;
  int p5;
  int p6;
  int p7;
  int p8;
  int p9;
  int p10;
  int p11;
  int p12;
  int p13;
  int p14;
  int p15;
} EventSearchAction;

typedef struct eventsearchdesc {
  TimeStamp64 delay;
  TimeStamp64 width;
  char node_name[NAMELEN];
  int cluster_number;
  int cluster_length;
  int weight;
  int nhistograms;
  int ntacs;
  int noutputs;
  int nactions;
  EventSearchAction action[MAX_EVENTSEARCH_ACTIONS];
}EventSearchDesc;

/* States of a specific cluster during event search ... */

#define ES_UNASSIGNED      0
#define ES_ASSIGNED        1

#endif

