# * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#                                                                       *
#       E U R O G A M    H I G H   V O L T A G E   C O N T R O L        *
#                                                                       *
#       File:   common.list.tcl                                         *
#                                                                       *
#       Author(s):      Jomar Honsi     Date:   18/03/91                *
#                                                                       *
#       Revision record:                                                *
#                                                                       *
# * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

proc next-list-value {v vals} {
# Find next element in a list
    set i [lsearch $vals $v]
    set i [expr ($i+1)%[llength $vals]]
    set v [lindex $vals $i]
    return $v
}

proc lsum arg {
    set sum 0
    foreach e $arg {
	set sum [expr $sum+$e]
    }
    return $sum
}

proc lmean arg {
    set sum 0
    set n 0
    foreach e $arg {
	set sum [expr $sum+$e]
	incr n
    }
    return [expr $sum/$n]
}

proc lmax arg {
    set max -10000
    foreach e $arg {
	if {$e>$max} {set max $e}
    }
    return $max
}

proc lmin arg {
    set min 10000
    foreach e $arg {
	if {$e<$min} {set min $e}
    }
    return $min
}

proc lor arg {
    set l [lindex $arg 0]
    set e [lindex $arg 1]
    set p [lsearch $l $e]
    if {$p==-1} {set l [lappend l $e]}
    return $l
}

proc land arg {
    set l1 [lindex $arg 0]
    set l2 [lindex $arg 1]
    set nl {}
    foreach el $l1 {
	set p [lsearch $l2 $el]
	if {$p!=-1} {set nl [lappend nl $el]}
    }
    return $nl
}

proc lxor arg {
    set l1 [lindex $arg 0]
    set l2 [lindex $arg 1]
    set nl {}
    foreach el $l1 {
	set p [lsearch $l2 $el]
	if {$p==-1} {set nl [lappend nl $el]}
    }
    foreach el $l2 {
	set p [lsearch $l1 $el]
	if {$p==-1} {set nl [lappend nl $el]}
    }
    return $nl
}

proc lremove arg {
    set l [lindex $arg 0]
    set p [lindex $arg 1]
    set pl [expr $p-1]
    set pu [expr $p+1]
    set l1 [lrange $l 0 $pl]
    set l2 [lrange $l $pu end]
    return [concat $l1 $l2]
}

proc lshift arg {
    return [lrange $arg 1 end]
}
