# * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#                                                                       *
#       E U R O G A M    H I G H   V O L T A G E   C O N T R O L        *
#                                                                       *
#       File:   common.unix.tcl                                         *
#                                                                       *
#       Author(s):      Jomar Honsi     Date:   18/03/91                *
#                                                                       *
#       Revision record:                                                *
#                                                                       *
# * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

proc fopen {name {attr r} } {
    set err [catch {set f [open $name $attr] } m]
    if {$err} {
	display-error-report self $m
    }
    return $f
}

proc isComment? {s} {
    if { $s =="" } {
	set b 1
    } else {
	set b [expr { [string index $s 0]=="#" } ]
    }
    return $b
}

proc read-files {args} {
    set buf ""
    foreach f $args {
	set fp [fopen $f r]
	if {$fp==0} return ""
	while 1 {
	    set t [gets $fp]
	    if {[eof $fp]} {break}
	    if { ! [isComment? $t] } { lappend buf $t }
	}
	close $fp
    }
    return $buf
}

proc write-file {f args} {
    set fp [fopen $f w+]
    foreach buf $args {
	foreach line $buf {
	    puts $fp $line
	}
    }
    close $fp
    set-footer "Saved to $f"
}

proc do-unix {cmd} {
    set z [catch {exec $cmd} m]
    if {$z} {
	display-error-report self $m
	set m (ERROR)
    }
    return $m
}
