
set frametitle "TDR Input Online Handler Control"

set currentvolume "NET"
set currentfile "NET"
set currentstart 0
set currentend 0

set z [catch {set env(OSTYPE)} m]
if {$z} {set ostype solaris} {set ostype $m}
if {$ostype == "solaris"} {
  set devlist {"Not_Active" "Net" "Other?"}
  } {
  set devlist {"Not_Active" "Net" "Other?"}
  }

#------------------------------------------------------------------------------

proc click arg {
   global debug chan
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$f=="ER"} then {cleanup-frame; return}
   if {$c==":quit"} then {click-quit; return}
   clear-footer
   switch -glob $w {

      ADD                    {click-add}
      REPLACE                {click-replace}
      REMOVE                 {click-remove}
      SAVE                   {click-save}

      MYHELP                   {click-help}
      REFRESH                {click-refresh}

      GO                     {click-handler-go}
      STOP                   {click-handler-stop}

      default                {puts stdout $arg}
   }
}
#------------------------------------------------------------------------------

proc make-frame {} {
   global debug
   global env
   global handlerlist handlerselected handlerloaded status
   global devlist debugmenustrings
   global runfilelist

   if {$debug} {puts stdout "make-frame: frame=[self frame-name]"}
   if {$debug} {puts stdout "...devlist=$devlist"}

  set vx3 150
  set twid1 15
  set twid2 45

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/sort" \
      :icon-name "[self icon-title]" :resize F

  :panel BUTTONS  :layout B :padx 10 :pady 10
     :layout H; :row-gap 20; :col-gap 5
      :button GO   :label Go
      :button STOP :label Stop
      :button REFRESH :label "Refresh" :x $vx3 
      :button MYHELP :label "Help" :w 12
  :panel OPTIONS  :layout L :padx 10 :pady 10
     :layout H; :row-gap 20; :col-gap 10
      :message INPUT-HANDLER :label "Input handler:    $handlerloaded" :bold T
      :text INPUT-HANDLER-STATUS :label "Status:" :value $status :bold T \
         :w $twid1 :valuex $vx3
      [:path INPUT-HANDLER-STATUS].entry configure -bd 0
   :show T
}

proc paint-handler-status {} {
   global status basedir
    set status 0
   :modify INPUT-HANDLER-STATUS :value $status
   }

proc repaint {} {
   global basedir handlerselected handlerloaded
   global devlist device1selected
   global tracelist tracelevel

   :modify INPUT-HANDLER :label "Input handler:    $handlerloaded"
   paint-handler-status

   paint-runfiles
   }

proc paint-runfiles {} {
   }
                 
proc click-add {} {
   global runfilelist runfileselected
   global currentvolume currentfile currentstart currentend
   frame-busy
    set currentvolume NET
   set currentfile NET
   if { $currentstart == ""} {set currentstart 0}
   if { $currentend == ""} {set currentend 0}
   set runfileselected [llength $runfilelist]
   set l "$runfileselected $currentvolume $currentfile $currentstart $currentend"
   lappend runfilelist [format-runfile $l]
   paint-runfiles
   frame-idle
   }

proc click-insert {} {
   global runfilelist runfileselected
   global currentvolume currentfile currentstart currentend
   frame-busy
   if { $currentvolume == ""} {frame-idle; return}
   if { $currentfile == ""} {frame-idle; return}
   if { $currentstart == ""} {set currentstart 0}
   if { $currentend == ""} {set currentend 0}
   set l "$runfileselected $currentvolume $currentfile $currentstart $currentend"
    set runfilelist [linsert $runfilelist [expr $runfileselected +1] [format-runfile $l]]
   paint-runfiles
   frame-idle
   }

proc click-replace {} {
   global runfilelist runfileselected inhandler
   global currentvolume currentfile currentstart currentend
   frame-busy
   if {![llength $runfilelist]} then {
      click-add
      frame-idle
      return
      }
    if {$inhandler == 1} {set currentvolume DISC}
   set l "$runfileselected $currentvolume $currentfile $currentstart $currentend"
   set l [format-runfile $l]
   set runfilelist [lreplace $runfilelist $runfileselected $runfileselected $l]
   paint-runfiles
   frame-idle
   }

proc init-values {} {
   global debug
   global devlist device1selected

   return 0
   }


proc start-handler args {
   global started
   if {![init-values]} then { 
      make-frame
      update idletasks
      click-refresh
      set started 1
      }
   }
