proc show-template-variables {t} {
    clear-footer
    set buf [print_template_variables $t]
    make-variables-frame $buf "Great Event Builder Template Variable listing"
    
    frame-idle
   }


proc show-cluster-variables {win} {
    global clusterlist
    clear-footer
    set i [$win.list curselection]
    if {$i == ""} {set-footer "No selection";return}
    set clus [lindex $clusterlist $i]

    set buf [print_cluster_variables $clus]
    make-variables-frame $buf "Great Event Builder Cluster Variable listing"
    
    frame-idle
   }

proc show-node-variables {node} {
    clear-footer
    set buf [print_node_variables $node]
    make-variables-frame $buf "Great Event Builder NodeVariable listing"
    
    frame-idle
   }

proc click-dismiss-variables {} {
   destroy [self frame-name].variables
}

proc make-variables-frame {list message} {

    set newlist ""
    foreach l $list {
	set var [first $l]
	if {[llength $l] < 2} {set val ""} {
	    set n [string length [first $l]]
	    set val [string range $l [expr $n +1] end]
       }
	set f [format "%-32s %-s" $var $val]
	append newlist "$f\n"
    }

   :frame [self frame-name].variables :transient T :label $message
   :font local text n :fmly courier :pxlsz 14
   :layout B
   :panel BUTTONS  :layout B :padx 120 :pady 0
   :button DISMISS :label Dismiss :command click-dismiss-variables
   :panel MAIN  :layout B :padx 0 :pady 0
   :galley LISTING  :rows 30 :cols 80 :deaf T
   :modify LISTING :strings $newlist :see 0

   :show T
}









