/* Definitions for layout/processing of input cluster params ... */

#ifndef CLUSTERDATAInc
#define CLUSTERDATAInc

/* Cluster data processing record ... */

typedef struct clusterinstance {
  int number;
  int nparamsfound;
  int nrequiredfound;
  unsigned short paramsfound[MAXPARAMSPERINSTANCE];
  unsigned short pileupdelay[MAXPARAMSPERINSTANCE];
  unsigned long long param[MAXPARAMSPERINSTANCE];
  TimeStamp64 paramTS[MAXPARAMSPERINSTANCE];
} ClusterInstance;

typedef struct clustergroup {
  int ninstances;
  int instancesfound[MAX_INSTANCES];
  ClusterInstance instance[MAX_INSTANCES];
} ClusterGroup;

typedef struct clusterdata {
  TimeStamp64 startTS;
  unsigned short nparams;
  unsigned short number;
  int ngroups;
  int groupsfound[MAX_GROUPS_PER_CLUSTER];
  ClusterGroup group[MAX_GROUPS_PER_CLUSTER];
  int slotnum;
} ClusterData;

#endif

