#ifndef SHMHISTInc
#define SHMHISTInc

#include <shm.h>

#define NAMELEN        31
#define ALLOC_NAMELEN  64
#define BUFLEN       8192
#define MAXSPECTRA   4096

#ifndef TRUE
#define TRUE            1
#endif
#ifndef FALSE
#define FALSE           0
#endif

#define ERROR          -1
#define DIRECTORY_END   0
#define SPECTRUM        1
#define DIRECTORY       2

/* spectra variables ----------------*/

struct spectable {          /* all spectra are signed precision */
  char name[ALLOC_NAMELEN];
  int dimensions;                  /* 1, 2 or 3 */
  int precision;                   /* in bytes  */
  int type;                        /* 0=1D, 1=2D, 3=cuboid, 4=3D */
  int bases[3],ranges[3];
  int exists;
  int shmid;
  void *address;
  int space;                       /* in bytes  */
  int disc_based;
};

#define min(a,b)    ( a < b ? a : b)
#define makelower(c)	( isupper(c) ? tolower(c) : c)
#define makeupper(c)	( islower(c) ? toupper(c) : c)

void *shmhist_connect();

#endif
