#!../tree_wish -f
# -*-Tcl-*-
#
# dirtree8 - same as dirtree7, but adds editing capabilities


loadsource dirtree7

# If the current selection is a leaf, add its subnodes, otherwise
# remove them

proc ToggleChildren {canvas tree} {
    set path [GetPath $canvas]
puts "ToggleChildren  $path [$tree isleaf $path]"
if {[$tree isleaf $path]} {
	ListDirs $canvas $tree $path
	$tree draw
    } else {
	$tree prune $path
    }
}


# If the selected node is the root of the tree, add its parent and siblings
# to the tree, otherwise make the selected node the new root of the tree.

proc ToggleParent {canvas tree} {
    global dirtree
    set path [GetPath $canvas]
    if [$tree isroot $path] {
	set dir [file dirname $path]
	if {$dir != $path} {
	    AddDir $canvas $tree "" $dir [set [list [file tail $dir](name)]]
	    set tail [file tail $path]
	    foreach i [exec ls $dir] {
		if {[file isdirectory $dir/$i]} {
		    if {$i == $tail} {
			$tree movelink $path $dir
		    } else {
			AddDir $canvas $tree $dir $dir/$i "$i"
		    }
		}
	    }
	    $tree draw
	}
    } else {
	$tree root $path
    }
}
