
set frametitle "TDR Output TapeServer Handler Control"

set defaulthost "ggreatTS"
set defaultport 10305
set currenthost $defaulthost
set currentport $defaultport

set z [catch {set env(OSTYPE)} m]
if {$z} {set ostype solaris} {set ostype $m}
if {$ostype == "solaris"} {
  set devlist {"Not_Active" "Net" "Other?"}
  } {
  set devlist {"Not_Active" "Net" "Other?"}
  }

#------------------------------------------------------------------------------

proc click arg {
   global debug chan
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$f=="ER"} then {cleanup-frame; return}
   if {$c==":quit"} then {click-quit; return}
   clear-footer
   switch -glob $w {

      MYHELP                   {click-help}
      REFRESH                {click-refresh}

      HOST                   {click-host $v}
      PORT                   {click-port $v}

      READRUNFILES           {click-load-runfiles}
      GO                     {click-handler-go}
      STOP                   {click-handler-stop}
      SAVE                   {click-setrunfile}

      default                {puts stdout $arg}
   }
}
#------------------------------------------------------------------------------

proc make-frame {} {
   global debug
   global env
   global handlerlist handlerselected handlerloaded status
   global devlist debugmenustrings
   global currenthost currentport outchannel

   if {$debug} {puts stdout "make-frame: frame=[self frame-name]"}
   if {$debug} {puts stdout "...devlist=$devlist"}

  set vx1 12c
  set vx2 150
  set vx3 250
  set twid1 15
  set twid2 15

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/sort" \
      :icon-name "[self icon-title]" :resize F

  :panel BUTTONS  :layout B :padx 10 :pady 10
     :layout H; :row-gap 20; :col-gap 5
#      :button GO   :label Go
#      :button STOP :label Stop
      :button READRUNFILES :label "Load from outruninfo[set outchannel] File"
      :button SAVE :label "Save" :w 4
      :button REFRESH :label "Refresh" :x $vx3 
      :button MYHELP :label "Help" :w 12
   :panel RUNFILES :layout B :padx 10 :pady 10
     :layout H; :row-gap 10; :col-gap 20
      :text HOST :label "Host:" :value $currenthost :w $twid2 :valuex $vx1
     :next-row T
      :text PORT :label "Port:" :value $currentport :w $twid2 :valuex $vx1
  :panel OPTIONS  :layout L :padx 10 :pady 10
     :layout H; :row-gap 20; :col-gap 10
      :message OUTPUT-HANDLER :label "Output handler: $outchannel   $handlerloaded" :bold T
      :text OUTPUT-HANDLER-STATUS :label "Status:" :value $status :bold T \
         :w $twid1 :valuex $vx2
      [:path OUTPUT-HANDLER-STATUS].entry configure -bd 0
   :show T
}

proc paint-handler-status {} {
   global status basedir
    set status 0
   :modify OUTPUT-HANDLER-STATUS :value $status
   }

proc repaint {} {
   global basedir handlerselected handlerloaded
   global devlist device1selected outchannel
   global tracelist tracelevel

   :modify READRUNFILES :label "Load from outruninfo[set outchannel] File"
   :modify OUTPUT-HANDLER :label "Output handler: $outchannel   $handlerloaded"
   paint-handler-status
   paint-runfiles
   }

proc paint-runfiles {} {
    global currentport currenthost
   :modify HOST :value $currenthost
   :modify PORT :value $currentport
   }
              
proc read-runinfo {} {
   global runfilelist runfileselected outchannel
   set runfilelist {}
   init-values
   set runfileselected 0
   paint-runfiles
   }
   
proc set-runinfo {} {
   global runfilelist
    global currentport currenthost

   set runfilelist {}
   set l "0 NET  $currenthost:$currentport 0 0"
   lappend runfilelist [format-runfile $l]
}

proc click-host {v} {
   global currenthost
   set currenthost $v
   set-runinfo
}

proc click-port {v} {
   global currentport
   set currentport $v
   set-runinfo
}

proc click-setrunfile {} {
   set-runinfo
    click-save
}

proc init-values {} {
   global outchannel currenthost currentport
   global defaulthost defaultport
   writereg runfileindex 0
   set r [readreg outputrunfiledata[set outchannel]]
   if {[second $r] == "NET"} {
      set v [split [third $r] ":"]
      set currenthost [first $v]
      set currentport [second $v]
   } {
      set currenthost $defaulthost
      set currentport $defaultport
   }
   return 0
   }


proc start-handler args {
   global started
   make-frame
   init-values
   update idletasks
   click-refresh
   set started 1
   }
