# util.tcl - utility routines for demos
# -*-Tcl-*-
#
# Author: Allan Brighton (abrighto@eso.org) 

option add *highlightThickness 0 
 
# create a canvas with horizontal and verical scrollbars in the 
# given frame with the given name

proc MakeCanvas {frame canvas} {
    set vscroll [scrollbar $frame.vscroll -command "$canvas yview"]
    set hscroll [scrollbar $frame.hscroll -orient horiz -command "$canvas xview"]
    set canvas [canvas $canvas -height 450 -width 700 -bg white \
		    -xscrollcommand "$hscroll set" \
		    -yscrollcommand "$vscroll set"] 
    pack $vscroll -side right -fill y
    pack $hscroll -side bottom -fill x
    pack $canvas -fill both -expand 1
    bind $canvas <ButtonPress-2> "$canvas scan mark %x %y"
    bind $canvas <B2-Motion> "$canvas scan dragto %x %y"

    return $canvas
}

# add the directories under $dir to the tree (recursive)
 
proc ListDirsRec {canvas tree dir} {
    set n [file tail $dir]
    global $n
    set [set n](path) $dir
    foreach i [set [set n](up)] {
        global $i
	AddDir $canvas $tree $dir $dir/$i [set [set i](name)]

	set open [set [set i](open)]
	if {$open} {
	    set frame [UniqueName $canvas $dir/$i]
	    MakeListFrame $canvas $tree $frame $dir/$i
	}

	ListDirsRec $canvas $tree $dir/$i
    }
# Add in any action definitions for this node ...
    foreach a [set [set n](actions)] {
        global $n$a
	AddDir $canvas $tree $dir $dir/$a "action [set n][set a]"
	set [set n][set a](path) $dir/$a
	set open [set [set n][set a](open)]
	if {$open} {
	    set frame [UniqueName $canvas $dir/$a]
	    MakeListFrame $canvas $tree $frame $dir/$a
	}

    }
}

# add the directories under $dir to the tree (non-recursive)
 
proc ListDirs {canvas tree dir} {
    set n [file tail $dir]
    global $n
    foreach i [set [set n](up)] {
        global $i
	AddDir $canvas $tree $dir $dir/$i [set [set i](name)]
    }
}











