#
#    Control of SHARC link configuration for GREAT
#

set frame SHARC
set frametitle "SHARC Links"
set icontitle  "Sharc"

set MaxTries 20
set Do_Register_Delete 0

#    hardware available.  Assumes maximum of 6 PMC (Asp) cards each having 6 SHARC links


set Sharc1 sharc1
set Sharc2 sharc2
set Sharc3 sharc3

set [set Sharc1]Present 0    ;#    discovered later from  experiment file
set [set Sharc2]Present 0    ;#    discovered later from  experiment file
set [set Sharc3]Present 0    ;#    discovered later from  experiment file

set syscon ""


set aspnums {1 0 3 2 5 4}
set linknums {5 4 3 2 1 0}

set AspsUsed 0
for {set asp 0} {$asp <= 5} {incr asp} {
   set AspInUse($asp) 0
   for {set link 0} {$link <= 5} {incr link} {
      set LinkInUse($asp,$link) 0
   }
}

set Configdir "$env(MIDASEXPBASE)"
catch {set Configdir "$env(EXPERIMENTBASE)"}

set Mergeregisterlist {}

lappend Mergeregisterlist [list Merge.Debug         merge   generic  "-nMerge_Debug -tint -fd"]
# Pileup netvar setup in sys.tcl
# lappend Mergeregisterlist [list Merge.PileupRate    merge   generic  "-nPileupRate -tint -fd"]

#lappend Mergeregisterlist [list NetVar.DACQ.Chistmode    merge   generic  "-nDACQ_HistMode -tint"]
#lappend Mergeregisterlist [list NetVar.DACQ.CPileupRate    merge   generic  "-nDACQ_PileupRate -tint"]
#lappend Mergeregisterlist [list NetVar.DACQ.InitialTimeStamp    merge   generic  "-nMerge_InitialTimeStamp -tuint"]
#lappend Mergeregisterlist [list NetVar.DACQ.Spaused    merge   generic  "-nMerge_IsPaused -tint"]

lappend Mergeregisterlist [list NetVar.DACQ.Stats.TotalCount    merge    generic  "-nDACQ_Stats -tuint -ayes -i1 -l1 -fd"]
lappend Mergeregisterlist [list NetVar.DACQ.Stats.BuffersInUse    merge    generic  "-nDACQ_Stats -tuint -ayes -i20 -l1 -fd"]

for {set asp 0} {$asp <= 5} {incr asp} {
    lappend Mergeregisterlist [list Merge.Asp$asp.Data         merge   generic  "-nasp[set asp]_Data -tint -fx"]
    lappend Mergeregisterlist [list Merge.Asp$asp.DataCounters merge   generic  "-nasp_DataCounters -tint -fx -a1 -i$asp"]
    lappend Mergeregisterlist [list Merge.Asp$asp.InUse        merge   generic  "-nMerge_AspsInUse -tint -a1 -i$asp"]
}
    lappend Mergeregisterlist [list Merge.LinksAvailable       merge   generic  "-nMerge_LinksAvailable -tint -fd"]

    lappend Mergeregisterlist [list Merge.EventBuffer         merge   generic  "-nMerge_EventBuffer -tint -fx"]
    lappend Mergeregisterlist [list Merge.Output.CurrPointer  merge   generic  "-nMerge_EventCurrent -tint -fd"]
    lappend Mergeregisterlist [list Merge.OutputPause         merge   generic  "-nMerge_OutputPause -tint -fd"]


proc find_sharc_servers {} {
    global sharc1Present sharc2Present sharc3Present

    set sharc1Present 0
    set sharc2Present 0
    set sharc3Present 0

    set z [catch {eg "(experiment ?resources)"} m]
    if {$z!=0} then {puts stderr "$m"; return}

    set rs $m

   foreach r $rs {
      set name [second [first $r]]
      set type [second [fourth $r]]
      set flags [second [eigth $r]]
      if {$name == "sharc1" && $type == "register" && $flags == "0x3"} then {set sharc1Present 1}
      if {$name == "sharc2" && $type == "register" && $flags == "0x3"} then {set sharc2Present 1}
      if {$name == "sharc3" && $type == "register" && $flags == "0x3"} then {set sharc3Present 1}
   }
}

#    list of registers required by the GUI
#     this is in addition to a similar set created in the base SYS task for Merge

set Collateregisterlist {}

find_sharc_servers

for {set asp 0} {$asp <= 5} {incr asp} {

#   if {$AspInUse($asp) == 0} continue
 
   if {$asp <= 1} then {
      set server $Sharc1
   } else {
      if {$asp <= 3} then {
         set server $Sharc2
      } else {
         set server $Sharc3
      }
   }

   if {[set [set server]Present] == 1} then {

      if {$syscon == ""} then {
          set syscon $server
          set SysResetregister [list VME.SYSRESET      $syscon    xMEM     "-a0xc2040000 -o0x404 -r1 -i0x00400000"]
      }

      for {set link 0} {$link <= 5} {incr link} {
          lappend Collateregisterlist [list Collate.Asp$asp.Link$link.InUse $server generic  "-nasp[set asp]_LinksInUse -tint -a1 -i$link"]
          lappend Collateregisterlist [list Collate.Asp$asp.Link$link.QDesc $server generic  "-nasp[set asp]_Queues_Desc -tint -fx -a1 -i[expr $link*5] -l5"]
          lappend Collateregisterlist [list Collate.Asp$asp.Link$link.QAddr $server generic  "-nasp[set asp]_Queues -tint -fx -a1 -i$link"]
          lappend Collateregisterlist [list Collate.Asp$asp.Link$link.QData      $server    bMEM     "-l64"]
      }
 
      lappend Collateregisterlist [list Collate.Asp$asp.EXEC.Usr1       $server    sigTask  "-tasp[set asp] -sUSR1"]
      lappend Collateregisterlist [list Collate.Asp$asp.EXEC.Usr2       $server    sigTask  "-tasp[set asp] -sUSR2"]
      lappend Collateregisterlist [list Collate.Asp$asp.EXEC.Action     $server    generic  "-nasp[set asp]_EXEC_Action -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.EXEC.Parameter  $server    generic  "-nasp[set asp]_EXEC_Parameter -tstring"]
      lappend Collateregisterlist [list Collate.Asp$asp.EXEC.Response  $server     generic  "-nasp[set asp]_EXEC_Response -tblock -ayes -i0 -l272 -fx"]
      lappend Collateregisterlist [list Collate.Asp$asp.EXEC.ID         $server    generic  "-nasp[set asp]_EXEC_ID -tstring"]
      lappend Collateregisterlist [list Collate.Asp$asp.EXEC.PID        $server    generic  "-nasp[set asp]_PID_EXEC -tint"]

      lappend Collateregisterlist [list Collate.Asp$asp.Stats.TotalCount    $server    generic  "-nasp[set asp]_DACQ_Stats -tuint -ayes -i1 -l1 -fd"]
      lappend Collateregisterlist [list Collate.Asp$asp.LocalData       $server    generic  "-nasp[set asp]_Local_Data -tint -fx"]
      lappend Collateregisterlist [list Collate.Asp$asp.Data            $server    generic  "-nasp[set asp]_Data -tint -fx"]
      lappend Collateregisterlist [list Collate.Asp$asp.DataCounters    $server    generic  "-nasp_DataCounters -tint -fx -a1 -i$asp"]
      lappend Collateregisterlist [list Collate.Asp$asp.CAlive          $server    generic  "-nasp[set asp]_DACQ_Alive -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.Ctxenable       $server    generic  "-nasp[set asp]_DACQ_TxEnable -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.Chistenable     $server    generic  "-nasp[set asp]_DACQ_HistEnable -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.Chistmode       $server    generic  "-nasp[set asp]_DACQ_HistMode -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.Ctrace          $server    generic  "-nasp[set asp]_DACQ_Trace -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.Sstate          $server    generic  "-nasp[set asp]_DACQ_State -tint"]

      lappend Collateregisterlist [list Collate.Asp$asp.TestMode        $server    generic  "-nasp[set asp]_DACQ_TestMode -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.DelayTicks      $server    generic  "-nasp[set asp]_DACQ_DelayTicks -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.PollTicks       $server    generic  "-nasp[set asp]_DACQ_PollTicks -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.Stats           $server    generic  "-nasp[set asp]_DACQ_Stats -tint -ayes -i0"]
      lappend Collateregisterlist [list Collate.Asp$asp.StatsArray      $server    generic  "-nasp[set asp]_DACQ_Stats -tint -ayes -i0 -l64"]
      lappend Collateregisterlist [list Collate.Asp$asp.StatsTime       $server    generic  "-nasp[set asp]_DACQ_StatsTime -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.Rates           $server    generic  "-nasp[set asp]_DACQ_Rates -tint -ayes -i0"]
      lappend Collateregisterlist [list Collate.Asp$asp.RatesArray      $server    generic  "-nasp[set asp]_DACQ_Rates -tint -ayes -i0 -l64"]

#      lappend Collateregisterlist [list Collate.Asp$asp.PauseData	$server    generic  "-nasp[set asp]_PauseData -tint"]
#      lappend Collateregisterlist [list Collate.Asp$asp.Full		$server    generic  "-nasp[set asp]_FullCounters -tint -ayes -i0 -l3"]

      lappend Collateregisterlist [list Collate.Asp$asp.StopHere	$server    generic  "-nasp[set asp]_StopHere -tint"]

      lappend Collateregisterlist [list Collate.Asp$asp.DataBuffer      $server    bMEM     "-l64"]

      lappend Collateregisterlist [list Collate.Asp$asp.OutputAll       $server    generic  "-nasp[set asp]_OutputAll -tint"]
      lappend Collateregisterlist [list Collate.Asp$asp.Output_BufferSize $server  generic  "-nasp[set asp]_Output_BufferSize -tint"]
   }
}

proc set-experiment dir {global Configdir; set Configdir $dir; restore_configuration}

proc define-register {class name attributes} {
   global EGallow Do_Register_Delete RegisterServer

   set EGallow_SAVE $EGallow
   set EGallow 0x20006         ;#   already exists

   set register /$RegisterServer/$name
   if {$Do_Register_Delete} {EG "register :pattern '$register' !delete"}
   set result [EG "register :name '$register' :class '$class' !new"]
   EG "register :name '$register' :object '$attributes'"

   set EGallow $EGallow_SAVE

   return $result
}

proc wait_for_completion {args} {
    global RegisterServer MaxTries

    set tries 1
    set TASK ""

    while {$tries < $MaxTries} {

        if {[llength $args] == 0} then {
            set-footer "Waiting for action to complete ($tries)"
        } else {
            if {[llength $args] > 1} then {
                set TASK "[first $args]."
                set-footer "[second $args] ($tries)"
            } else {
                set-footer "[first $args] ($tries)"
            }
        }

        set z [catch {EG "register :name '/$RegisterServer/[set TASK]EXEC.Action' ?value"} m ]

        if {$z != 0} then {
            midas-warning "Unable to confirm state of action\n$m"
            clear-footer
            return 1
        }

        if {$m == 0} then {
            clear-footer
            return 0
        }
        incr tries
        after 500
    }

    midas-warning "Action has not completed\nGiving up waiting"
    clear-footer
    return 1
}

proc make_registers {registerlist} {
    global EGreport RegisterServer

    set item [first $registerlist]
    set RegisterServer [second $item]
#    set r [define-register [third $item] [first $item] "[fourth $item]"]
#    if {$r == 0x20006} {return}          ;#  registers already exist

    set EGreport_SAVE $EGreport
    set EGreport -1
    set-footer "defining registers"

    foreach item $registerlist {
        set RegisterServer [second $item]
        define-register [third $item] [first $item] "[fourth $item]"
    }

    clear-footer
    set EGreport $EGreport_SAVE
}

proc restore_configuration {} {
   global Configdir
   global AspsUsed AspInUse LinkInUse

   set z [catch {open [file join $Configdir SHARC_current_configuration] r} file]
   if {$z != 0} then {set-footer "$file"; return}

   set configuration [split [read $file] \n]
   close $file

   set n 0
   set AspsUsed 0
   for {set asp 0} {$asp <= 5} {incr asp} {
       set AspInUse($asp) [lindex $configuration $n]
       if {$AspInUse($asp) == {}} then {set AspInUse($asp) 0}
       if {$AspInUse($asp) != 0} then {incr AspsUsed}
       incr n
       for {set link 0} {$link <= 5} {incr link} {
          set LinkInUse($asp,$link) [lindex $configuration $n]
          incr n
       }
   }
   display-SHARC
}

proc make_merge_registers {} {global Mergeregisterlist; make_registers $Mergeregisterlist}
proc make_collate_registers {} {global Collateregisterlist; make_registers $Collateregisterlist}

proc load_configuration {} {
    global EGreport
    global Configdir
    global AspInUse LinkInUse
    global RegisterServer
    global sharc1Present sharc2Present sharc3Present
    global Sharc1 Sharc2 Sharc3

   make_merge_registers
   make_collate_registers

   find_sharc_servers

   for {set asp 0} {$asp <= 5} {incr asp} {
      if {$asp <= 1} then {
         set RegisterServer $Sharc1
      } else {
         if {$asp <= 3} then {
            set RegisterServer $Sharc2
         } else {
            set RegisterServer $Sharc3
         }
      }
      if {[set [set RegisterServer]Present] == 1} then {
         write-attributes Collate.Asp$asp.Ctrace "-nasp[set asp]_DACQ_Trace -tint"
         write-attributes Collate.Asp$asp.Sstate "-nasp[set asp]_DACQ_State -tint"
      }
   }

   set EGreport_SAVE $EGreport
   set EGreport -1

   for {set asp 0} {$asp <= 5} {incr asp} {
      set RegisterServer merge
      write-register Merge.Asp$asp.InUse $AspInUse($asp)
      if {$asp <= 1} then {
         set RegisterServer $Sharc1
      } else {
         if {$asp <= 3} then {
            set RegisterServer $Sharc2
         } else {
            set RegisterServer $Sharc3
         }
      }
      if {[set [set RegisterServer]Present] == 1} then {
         for {set link 0} {$link <= 5} {incr link} {
            write-register Collate.Asp$asp.Link$link.InUse $LinkInUse($asp,$link)
         }
      }
   }

   set z [catch {open [file join $Configdir SHARC_current_configuration] w} file]
   if {$z != 0} then {set-footer "$file"; return}
   for {set asp 0} {$asp <= 5} {incr asp} {
      puts $file $AspInUse($asp)
      for {set link 0} {$link <= 5} {incr link} {
          puts $file $LinkInUse($asp,$link)
      }
   }
   close $file

   set EGreport $EGreport_SAVE
}

proc click-asp {asp} {
    global AspsUsed AspInUse RegisterServer

    set ThisAspInUse [expr ($AspInUse($asp) + 1) & 1]
    if {$ThisAspInUse != 0} then {set used [expr $AspsUsed + 1]} else {set used [expr $AspsUsed - 1]}
    set linksused [inform MergeLinks inquire LinksUsed]
    set totalused [expr $linksused + $used]
    set RegisterServer merge
    set avail [expr [read-register Merge.LinksAvailable] - $totalused]
    if {$avail < 0} then {
       midas-warning "No more Merge Links available"
       clear-footer
       return
    }
    set AspInUse($asp) $ThisAspInUse
    set AspsUsed $used
    display-SHARC
    inform MergeLinks display-Merge
}

proc click-link {asp link} {
    global AspInUse LinkInUse
    set LinkInUse($asp,$link) [expr ($LinkInUse($asp,$link) + 1) & 1]
    display-SHARC
}

proc action-sysreset {} {
    global syscon EGallow SysResetregister
    make_registers [list $SysResetregister]
    set egallow $EGallow
    set EGallow 0x1ffff
    EG "register :name '/$syscon/VME.SYSRESET' !initialise"
    set EGallow $egallow
}

proc do-sysreset {} {
    global started
    if {$started == 0} {make-frame; close-frame}
    set r [midas-confirmation "You are about to reboot the VME crate.\nAre you sure?"]
    if {$r == 1} then {after 100 action-sysreset}
}

proc display-SHARC {} {
   global AspInUse LinkInUse aspnums linknums

   for {set asp 0} {$asp <= 5} {incr asp} {

      set count [lsearch $aspnums $asp]

      if {$AspInUse($asp) == 0} then {
          [:path H$count].asp  configure -background red
      } else {
          [:path H$count].asp  configure -background green
      }

      for {set link 0} {$link <= 5} {incr link} {

          set i [lsearch $linknums $link]
          if {$LinkInUse($asp,$link) == 0} then {
              [:path H$count].link$i  configure -background red
          } else {
              [:path H$count].link$i  configure -background green
          }
      }
   }
}

proc do_setup {} {
    global sharc1Present sharc2Present sharc3Present AspInUse
    global Sharc1 Sharc2 Sharc3
    global RegisterServer

   find_sharc_servers

   for {set asp 0} {$asp <= 5} {incr asp} {
       
      if {$asp <= 1} then {
         set server $Sharc1
      } else {
         if {$asp <= 3} then {
            set server $Sharc2
         } else {
            set server $Sharc3
         }
      }

      if {[set [set server]Present] == 1} then {

         set RegisterServer merge
         set data [read-register Merge.EventBuffer]
#         write-attributes Merge.Output.DataBuffer "-a $data"
         set data [read-register Merge.Asp$asp.Data]
#         write-attributes Merge.Asp$asp.DataBuffer "-a $data"
         set RegisterServer $server
#         write-register Collate.Asp$asp.Data $data
#         set data [read-register Collate.Asp$asp.LocalData]
#         write-attributes Collate.Asp$asp.DataBuffer "-a $data"
         
         set RegisterServer $server
         for {set link 0} {$link <= 5} {incr link} {
            set data [read-register Collate.Asp$asp.Link$link.QAddr]
            write-attributes Collate.Asp$asp.Link$link.QData "-a $data"
         }

         set RegisterServer merge
         set data [read-register Merge.Asp0.DataCounters]
         set data [expr $data + 2 * 4 * $asp]
#         write-attributes Merge.Asp$asp.Produced "-a $data"
#         write-attributes Merge.Asp$asp.Consumed "-a $data"
         set RegisterServer $server
         write-register Collate.Asp$asp.DataCounters $data

         if {$AspInUse($asp) == 0} continue
         
         set RegisterServer $server
         set pid [read-register Collate.Asp$asp.EXEC.PID]
         write-attributes Collate.Asp$asp.EXEC.Usr1 "-t $pid"
         write-register Collate.Asp$asp.EXEC.Action 3
         write-register Collate.Asp$asp.EXEC.Usr1 0
         wait_for_completion Collate.Asp$asp "waiting for $RegisterServer Asp$asp"
      }
   }
}

proc do_command {command} {
    global sharc1Present sharc2Present sharc3Present AspInUse
    global Sharc1 Sharc2 Sharc3
    global RegisterServer
    
    open-frame

   for {set asp 0} {$asp <= 5} {incr asp} {
   
      if {$AspInUse($asp) == 0} continue
    
      if {$asp <= 1} then {
         set server $Sharc1
      } else {
         if {$asp <= 3} then {
            set server $Sharc2
         } else {
            set server $Sharc3
         }
      }

      if {[set [set server]Present] == 1} then {
         set RegisterServer $server

         set pid [read-register Collate.Asp$asp.EXEC.PID]
         write-attributes Collate.Asp$asp.EXEC.Usr1 "-t $pid"
         write-register Collate.Asp$asp.EXEC.Action $command
         write-register Collate.Asp$asp.EXEC.Usr1 0
         wait_for_completion Collate.Asp$asp "waiting for $RegisterServer Asp$asp"
      }
   }
}

proc inquire_AspInUse asp {
   global AspInUse debug
   if {$debug} {
     insert-debug "AspInUse($asp): $AspInUse($asp)"
   }
   return $AspInUse($asp)
}

proc auto_start {} {
   global started frame
   set z [catch {winfo ismapped [:path $frame]} is_open]
   if {$z} {set is_open 0}
   start
   if {!$is_open} {close-frame}
}

proc start args {
   global started  frame
   if {$started == 0} then {make-frame;restore_configuration} else {open-frame}
   set started 1
   display-SHARC
# Don't understand why an after is needed.
# Calling it directly produced the wrong display
# so I tried a minimal after - it works.
   after 1 inform MergeLinks display-Merge
   return
}


proc make-frame {} {
   global env aspnums linknums

  :frame [self frame-name] :label "[self frame-title]" :show-footer T  :resize F

   :panel M :layout T :padx 10 :pady 10
     :layout H; :row-gap 10; :col-gap 20
     :hskip 50
     :message M0 :label "SHARC links" :bold T

   :panel B :layout B :padx 10 :pady 10 :after FOOTER
     :layout H; :row-gap 10; :col-gap 20

    :button CONFIGURE :command load_configuration

   set count 0

  foreach panel {0 1 2} {

   :panel P$panel :layout H :padx 10 :pady 10 
     :layout H; 

    foreach canvas {0 1} {

        set w $count

        :canvas H$w  :w 40 :h 126
        [:path H$w] config -background $env(tkframebackground) 

        set asp [lindex $aspnums $count]
        entry [:path H$w].asp -relief flat -width 1 -justify right -foreground black
        [:path H$w].asp insert 0 $asp
        :draw window :tag H[set w]asp :value 10 64 -window [:path H$w].asp
        bind [:path H$w].asp <ButtonPress-1>  "click-asp $asp"

        set y 15
        for {set i 0} {$i <= 5} {incr i} {
           set link [lindex $linknums $i]
           entry [:path H$w].link$i -relief flat -width 1 -justify right -foreground black
           [:path H$w].link$i insert 0 $link
           :draw window :tag H[set w]link$i :value 30 $y -window [:path H$w].link$i 
           bind [:path H$w].link$i <ButtonPress-1>  "click-link $asp $link"

           incr y 20
        }
        :next-row T
        incr count
    }
  }

   :show T
}

