#    name of the MIDAS server to use to access MPX modules

if {[info exists env(MUXserver)]} then {set MUXserver $env(MUXserver)} \
    else {set MUXserver vme}

set MUXrouting 1

#    names of the MPX modules connected to each inspection line
#      note -  register creation is in /MIDAS/config/VME

set MPXmodule(AI1) amux1
set MPXmodule(AI2) amux2
set MPXmodule(DI1) lmux3
set MPXmodule(DI2) lmux4
set MPXmodule(DI3) lmux5
set MPXmodule(DI4) lmux6

#    routing table
#    set routing(line,vxin) m
#    to connect inspection line for crate vxin write m to the MPX module register

set MPXrouting(AI1,vxi1) 0
set MPXrouting(AI1,vxi2) 1
set MPXrouting(AI1,vxi3) 2
set MPXrouting(AI1,vxi4) 3

set MPXrouting(AI2,vxi1) 4
set MPXrouting(AI2,vxi2) 5
set MPXrouting(AI2,vxi3) 6
set MPXrouting(AI2,vxi4) 7

set MPXrouting(DI1,vxi1) 0
set MPXrouting(DI1,vxi2) 1
set MPXrouting(DI1,vxi3) 2
set MPXrouting(DI1,vxi4) 3

set MPXrouting(DI2,vxi1) 4
set MPXrouting(DI2,vxi2) 5
set MPXrouting(DI2,vxi3) 6
set MPXrouting(DI2,vxi4) 7

set MPXrouting(DI3,vxi1) 0
set MPXrouting(DI3,vxi2) 1
set MPXrouting(DI3,vxi3) 2
set MPXrouting(DI3,vxi4) 3

set MPXrouting(DI4,vxi1) 4
set MPXrouting(DI4,vxi2) 5
set MPXrouting(DI4,vxi3) 6
set MPXrouting(DI4,vxi4) 7


set MPXchannel(AI1) rlyA0
set MPXchannel(AI2) rlyA1
set MPXchannel(DI1) rlyB0
set MPXchannel(DI2) rlyB1
set MPXchannel(DI3) rlyA0
set MPXchannel(DI4) rlyA1

#    connection table

set MPXconnect(AI1) 2
set MPXconnect(AI2) 2
set MPXconnect(DI1) 1
set MPXconnect(DI2) 1
set MPXconnect(DI3) 1
set MPXconnect(DI4) 1


proc connect-inspection {line crate} {
   global MUXserver MUXrouting MPXmodule MPXrouting MPXchannel MPXconnect

#    check option present and enabled

   if {$MUXserver == "" || $MUXrouting == 0} then {return}

#    disconnect anything currently using the scope channels this will use

   set register /$MUXserver/MPX?.$MPXchannel($line)
   set value 0

   catch {EG "register :pattern '$register' :value '$value'"}

#    set channel assignment

#   create register name and value to write

   set register /$MUXserver/ISM.$MPXmodule($line)
   set value [expr $MPXrouting($line,$crate) + 8]

#   execute

    catch {EG "register :pattern '$register' :value '$value'"}

#    connect scope channel

#   create register name and value to write

   set register /$MUXserver/ISM.$MPXchannel($line)
   set value $MPXconnect($line)

#   execute

    catch {EG "register :pattern '$register' :value '$value'"}

}
